#!/usr/bin/perl
# collapse Pfam motif-repeat domains
# first file should be a file on format
# PFXXXXX <Repeat/Motif>
# with one row for each Pfam domain of type Motif/Repeat
# remaining input arguments should be names of files which should undergo repeat/motif collapsing

open (FH2, $ARGV [0]) or die trying;

%repeatMotifs = ();

while (<FH2>) {

 $aLine = $_;
 chomp ($aLine);

 $aLine =~ /(^\S*)\s+(\S*$)/;

 $repeatMotifs {$1} = "";

}

close (FH);

for ($i = 1; $i < @ARGV; $i++) {

$file = $ARGV [$i];

open (FH, $file) or die trying;
open (FH2, ">$file.collapsed") or die trying;

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 $aLine =~ /(^\S*)\s+(\S*$)/;

 $name = $1;
 $arch = $2;

 $newArch = "";
 $previousDomain = "";

 @domains = split (/\*/, $arch);

 foreach $domain (@domains) {

  if (! exists ($repeatMotifs {$domain}) || ! ($previousDomain eq $domain)) {

   if ($newArch eq "") {

    $newArch = $domain;

   }

   else {

    $newArch = $newArch."*".$domain;

   }

  }

  $previousDomain = $domain;  

 }

 print FH2 "$name $newArch\n";

}

close (FH);
close (FH2);

}
